#ifndef HENGE_PIXMAP_H_
#define HENGE_PIXMAP_H_

#include "int_types.h"

namespace henge {

enum image_file_fmt {
	IFMT_PNG,
	IFMT_JPEG,
	IFMT_TGA,
	IFMT_PPM,
	IFMT_RGBE,

	IFMT_GUESS
};

class pixmap {
public:
	int xsz, ysz;
	uint32_t *pixels;

	pixmap();
	pixmap(int xsz, int ysz, uint32_t *img = 0);
	~pixmap();

	bool set_pixels(uint32_t *img, int xsz, int ysz);

	bool load(const char *fname);
	bool save(const char *fname, image_file_fmt fmt = IFMT_GUESS) const;

	bool generate(const char *expr);
};

}	// namespace henge

#endif	// HENGE_PIXMAP_H_
