#ifndef VMATH_RAY_H_
#define VMATH_RAY_H_

#include <stack>
#include "vector.h"
#include "matrix.h"

class Ray {
private:
	std::stack<scalar_t> ior_stack;

public:
	/* enviornmental index of refraction, normally 1.0 */
	static scalar_t env_ior;
	
	Vector3 origin, dir;
	scalar_t energy;
	scalar_t ior;
	unsigned long time;

	Ray();
	Ray(const Vector3 &origin, const Vector3 &dir);

	void transform(const Matrix4x4 &xform);
	Ray transformed(const Matrix4x4 &xform) const;

	void enter(scalar_t new_ior);
	void leave();
};

#endif	/* VMATH_RAY_H_ */
