#ifndef GEOM_H_
#define GEOM_H_

#include <henge.h>
#include "sim.h"
#include "simobj.h"
#include <pthread.h>

struct BallStats {
	int num_spawned, num_collected;
	int *exit_counters;
	int num_exits;

	pthread_mutex_t mutex;
};

struct BoxParameters {
	int rows, cols;
	float pin_rad, pin_length;
	float row_dist, pin_dist;
	float width, height;
};
#define BOX_PARAM_INITIALIZER	{	\
	DEF_ROWS, DEF_COLS,				\
	DEF_PIN_RAD, DEF_PIN_LEN,		\
	DEF_ROW_DIST, DEF_PIN_DIST,		\
	0, 0 }

extern BallStats ball_stats;
extern BoxParameters box_param;

bool init_geom(henge::scene *scn, Simulation *sim);

henge::robject *get_ball_object(int btype);
double get_ball_mass(int btype);
double get_ball_restitution(int btype);
double get_ball_radius(int btype);

void drop_balls(Simulation *sim, int count, unsigned int type);

#endif	/* GEOM_H_ */
