#ifndef PROTO_H_
#define PROTO_H_

// GALTON networking protocol 1.0
#define TIMEOUT			3000
#define PING_TIMEOUT	8000

#define MESSAGES	\
	MSG(HELLO)		\
	MSG(SYNC)		\
	MSG(PING)		\
	MSG(ALIVE)		\
	MSG(SPAWN)		\
	MSG(COLLECT)	\
	MSG(PASS_BALL)	\
	MSG(BYE)

#define MSG(x)	MSG_##x,
enum {
	MESSAGES
	NUM_MESSAGES
};
#undef MSG

struct MsgHeader {
	int msg;
	int data_sz;
};

const char *get_msg_name(int msg);

bool send_msg_header(int s, const MsgHeader *hdr);
bool recv_msg_header(int s, MsgHeader *hdr, unsigned long timeout = -1);

int recv_data(int s, void *buf, int size, unsigned long timeout = -1);

void ping(int s);
void alive(int s);

class SimBall;
bool pass_ball(int s, const SimBall *ball);
void parse_ball_data(const unsigned char *data, SimBall *ball);

struct BallStats;
bool sync(int s, const BallStats *stats);
void parse_sync_data(const unsigned char *data, BallStats *stats);

#endif	// PROTO_H_
